
ChiliProject - Bug # 171: unit/user_test.rb:138 fails with mysql2 gem

Status: Closed Priority: Normal
Author: Gregor Schmidt Category: Testing
Created: 2011-02-10 Assignee: Eric Davis
Updated: 2011-02-15 Due date:
Remote issue URL:
Affected version:
Description: I'm seeing the following error when running @rake test:units@

<pre>
  1) Failure:
test: User#try_to_login should select the exact matching user first. (UserTest)
    [/test/unit/user_test.rb:145:in `__bind_1297359790_531508'
     shoulda (2.10.3) lib/shoulda/context.rb:362:in `call'
     shoulda (2.10.3) lib/shoulda/context.rb:362:in `test: User#try_to_login should select the exact matching 
user first. ']:
<"ADMIN"> expected but was
<"admin">.
</pre>

History
2011-02-10 05:52 pm - Gregor Schmidt
- Status changed from Open to Ready for review

Pull request at: https://github.com/chiliproject/chiliproject/pull/3

2011-02-12 03:16 pm - Felix Schäfer
Looks fine to me. Any naysayers?

2011-02-14 01:13 am - Eric Davis
- Assignee set to Eric Davis

I'll check it out right now. Still getting my test env all setup.

2011-02-14 01:48 am - Eric Davis
- Category changed from User accounts to Testing

- Status changed from Ready for review to Needs more information

How did you set this up? mysql2 won't even run the unit test suite.

<pre>
$ r test:units --trace
(in /home/edavis/dev/chiliproject/core)
** Invoke test:units (first_time)
** Invoke db:test:prepare (first_time)
** Invoke db:abort_if_pending_migrations (first_time)
** Invoke environment (first_time)
** Execute environment
** Execute db:abort_if_pending_migrations
** Execute db:test:prepare
** Invoke db:test:load (first_time)
** Invoke db:test:purge (first_time)
** Invoke environment 
** Execute db:test:purge
rake aborted!
Task not supported by 'mysql2'
/usr/lib/ruby/gems/1.8/gems/rails-2.3.5/lib/tasks/databases.rake:384
</pre>

2011-02-14 08:46 am - Holger Just
- Status changed from Needs more information to Open

mysql2 doesn't support all of the rake tasks by default. Gregor compiled a simple Rails plugin to fix this and add all those rake tasks to mysql too. See 
https://github.com/finnlabs/mysql2_for_rails_2_3_5.

2011-02-14 08:58 am - Gregor Schmidt
- Status changed from Open to Ready for review

Thanks for taking the time and looking into it.

Unfortunately, the mysql2 gem is not yet fully supported in Rails 2.3.5. This is caused by the database rake tasks being to restrictive when testing for 
MySQL ("#5592 in Rails' 
Lighthouse":https://rails.lighthouseapp.com/projects/8994/tickets/5592-patch-dont-raise-task-not-supported-by-exception-for-mysql2-adapter-in-2-3-stab
le). This should be fixed with Rails 2.3.10.

When using mysql2 in production, this is not an issue, since the db:migrate task works fine and that's the only task, you might want to run on a 
production system. On the other hand mysql2 is actively maintained and claims to be a faster option.

There are 2 options to reproduce the error within the test suite.

1. Run @RAILS_ENV=test db:migrate@ to migrate the test db and execute the test file in isolation, therefore avoiding the breaking rake tasks: @ruby 
-Itest:lib test/unit/user_test.rb@

2. Install the "mysql2_for_rails_2_3_5":https://github.com/finnlabs/mysql2_for_rails_2_3_5 Rails plugin. It includes all the necessary fixes, back ported 
to Rails 2.3.5 using monkey patching. When this plugin is installed, everything should work the same way as with the mysql gem.

Let me know, if I can help out further.

FYI: The continuous integration currently running at ci.nach-vorne.eu uses the second approach. I will write something up on how to get everything 
running and all open bug reports on other projects.

2011-02-14 11:45 pm - Eric Davis
- Status changed from Ready for review to Closed

Gregor Schmidt:

After installing the plugin the tests started working with mysql2. I've reviewed your patch and merged it into master.
Thanks for the patches.

2011-02-15 08:16 am - Gregor Schmidt
Thanks for taking the time.
